/*
    WN: A Server for the HTTP
    File: wnmysqlauth/wnmysqlauth.c
    Version 0.9.0
    
    Copyright (C) 1998  <by Matthias Cramer>
    
    Based on wnauth by John Franks

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 1, or (at your option)
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*/

#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <unistd.h>
#include <sys/signal.h>
#include <mysql/mysql.h>
#include "wnmysqlauth.h"

#define AUTHWN_TIMEOUT	(60)
#define GROUPLEN	(8192)

extern char *optarg;
extern int optind;

extern char	*crypt(),
		*getenv();

static char	group[SMALLLEN],
		*mystrncpy();

static void	chop(),
		authwn_timeout();

static int	checkpw();

int		crypted = FALSE;

int
main( argc, argv)
int	argc;
char	*argv[];

{
	register char	*cp;

	char	authdata[MIDLEN + 2*SMALLLEN],
		decoded[SMALLLEN];

	int	c;

	signal( SIGALRM, authwn_timeout);
	alarm( AUTHWN_TIMEOUT);

	while ((c = getopt(argc, argv, "C")) != -1) {
		switch ((char) c) {
			case 'C':
				crypted = TRUE;
				break;
		}
	}

	mystrncpy( group, argv[optind], SMALLLEN);

	if ( !*group) {
		exit( AUTHERR_NUM7);
	}

	if ( fgets( authdata, SMALLLEN, stdin) == NULL) {
		exit( AUTHERR_NUM10);
	}

	chop( authdata);
	cp = authdata;
	while ( isspace( *cp))
		cp++;
	while ( *cp && !isspace( *cp))
		cp++;
	*cp++ = '\0';

	while ( isspace( *cp))
		cp++;

	mystrncpy( decoded, cp, SMALLLEN);

	if ( checkpw( decoded ) ) {
		exit( AUTH_GRANTED);
	}
	else {
		exit( AUTH_DENIED);
	}
}

static int
checkpw( userinfo )
char	*userinfo;
{
	register char	*cp;
	char		*user,
			*pw,
                        codedpw[SMALLLEN],
			info[SMALLLEN];
	MYSQL		mysql, *sock;
	MYSQL_RES	*result;
	MYSQL_ROW	row;
	MYSQL_FIELD     *field;
	
	int             i,length;
	
	int		found;
	int             rows;
	
	char		statment[254];

	codedpw[0] = '\0';
	mystrncpy( info, userinfo, SMALLLEN);

	if ( (cp = strchr( info, ':')) == NULL )
		exit( AUTHERR_NUM3);

	*cp = '\0';
	user = info;
	pw = ++cp;

        if (!(sock = mysql_connect(&mysql, dbhost, dbuser, dbpasswd))) {
          fprintf(stderr,"Couldn't connect to engine!\n%s\n\n",mysql_error(&mysql));
          perror("");                                                               
          exit(1);
        }
        if (mysql_select_db(sock, DATABASE) <0 ) {
          fprintf(stderr,"Couldn't select database %s!\n%s\n",DATABASE, mysql_error(sock));                                 
          exit(1);
        }
	
	if (crypted) {
	  sprintf(statment, "select id from %s where user like '%s' AND password like PASSWORD('%s') AND authgroup like '%s'", TABLE, user, pw, group);
	} else {
	  sprintf(statment, "select id from %s where user like '%s' AND password like '%s' AND authgroup like '%s'", TABLE, user, pw, group);
	}

/* 	fprintf(stderr, "Statment=%s\n",statment);  */

	if ((rows=mysql_query(sock, statment)) <0 || !(result=mysql_use_result(sock))) {
	  fprintf(stderr,"Query failed (%s)\n",mysql_error(sock));
	  exit(1);
	}
	
/* 	fprintf(stderr, "Rows= %i\n",rows); */

	found = FALSE;
		
	while ((row = mysql_fetch_row(result))) {
	  mysql_field_seek(result,0);
	  for (i=0 ; i < mysql_num_fields(result); i++)
	    {
	      field = mysql_fetch_field(result);
	      /*	      length=field->max_length;         
			      fprintf(stderr, " %-*s|",length+1,row[i] ? (char*) row[i] : ""); */
	    }

	  found = TRUE;
	 
	}

	/*	fprintf(stderr, "\n"); */
	
	mysql_free_result(result);
	mysql_close(sock);

/* 	fprintf(stderr, "User=%s, Password=%s, Group=%s\n", user, pw, group); */

	if (found == TRUE) {
/* 	  fprintf(stderr, "Found\n"); */
	  return TRUE;
	} else {
/* 	  fprintf(stderr, "Not Found\n"); */
	  return FALSE;
	}

}



static void
chop( line)
char *line;
{
	register char	*cp;

	if ( *line == '\0')
		return;
	cp = line;
	while ( *cp )
		cp++;
	if ( *--cp == '\n') {
		*cp = '\0';
	}
}


/*
 * mystrncpy( s1, s2, n) is an strncpy() which guarantees a null
 * terminated string in s1.  At most (n-1) chars are copied.
 */

static char *
mystrncpy( s1, s2, n)
char	*s1,
	*s2;
int	n;
{
	register char	*cp1,
			*cp2;
	cp1 = s1;
	cp2 = s2;
	n--;
	while ( *cp2 && (n > 0)) {
		n--;
		*cp1++ = *cp2++;
	}
	*cp1 = '\0';
	return s1;
}

static void
authwn_timeout()
{
	signal( SIGALRM, SIG_DFL);
	exit( AUTHERR_NUM16);
}
